class Feature
	attr_accessor :source, :type, :start, :stop, :score, :strand, :phase, :attribs, :child
	@@undefined_features=0
	def initialize(source, type, start, stop, score, strand, phase, attribs)
		@source=source
		@type=type
		@start=start.to_i
		@stop=stop.to_i
		if score=='.'
			@score='.'
		else
			@score=score.to_f
		end
		@strand=strand
		if phase=='.'
			@phase='.'
		else
			@phase=phase.to_i
		end
		@attribs=attribs
		if attrib('Name').nil? #Añade el atributo name en base a la ID de forma automatica
			@attribs['Name']=attrib('ID')
    else
      revised_name = @attribs['Name']
      revised_name.gsub!(';','-')
      @attribs['Name'] = revised_name
		end
		@child={}
	end

	def add_child(source, type, start, stop, score, strand, phase, attribs)
	  child=Feature.new(source, type, start, stop, score, strand, phase, attribs)
	  if !attribs['ID'].nil?
    		@child[attribs['ID']]=child
    else
    		@child[child.attrib('Parent')+'_'+@@undefined_features.to_s]=child
    		@@undefined_features+=1
    end
    return child
	end
	
	def transfer_child(id,child)
	  @child[id]=child
	end
	
	def each_child
	  @child.each_value do |child|
	    yield child
	  end
	end
	
	def attrib(tag)
		attrib=@attribs[tag]
		return attrib
	end

  def each_tag_attrib
    @attribs.each do |tag,attrib|
      yield tag,attrib
    end
  end

	def inspects
		print attrib('ID')+" ---> "
		@child.keys.each do |ch|
			print "#{ch} (#{@child[ch].count})\t"
		end
		print "\n"
	end

	def count
		return @child.count
	end

	def cds
		cds_exones=[]
		@child.each do |key_cds|
			if key_cds[1].type=='CDS'
				cds_exones << [key_cds[1].start, key_cds[1].stop]
			end
		end
		return cds_exones
	end
	
	def tree(level=0)
    puts "\t"*level+"#{attrib('ID')}\t\t#{@type}\t#{@source}"
    level+=1
    each_child {|child|
      child.tree(level)
    }
	end
	
	def is_type?(type)
	  t=FALSE
    type=[type].flatten
    type.each do |typ|
      if typ == @type
        t=TRUE
        break
      end
    end
    return t
	end
	
  def is_source?(source)
    s=FALSE
    source=[source].flatten
    source.each do |sour|
      if sour == @source
        s=TRUE
        break
      end
    end
    return s
  end

  def compare(feature) #Resultado oscila entre 0 y 1
    overlap=0
    if feature.start >= self.start && feature.start <= self.stop && feature.stop >= self.start && feature.stop <= self.stop
      overlap=feature.length*1.00/self.length
    elsif  self.start >= feature.start && self.start <= feature.stop && self.stop >= feature.start && self.stop <= feature.stop
      overlap=1
    elsif feature.start > self.start && feature.start < self.stop   
      overlap=(self.stop-feature.start)*1.00/self.length
    elsif feature.stop > self.start && feature.stop < self.stop
      overlap=(feature.stop-self.start)*1.00/self.length
    end
    return overlap
  end
  
  def length
    length=self.stop-(self.start-1)
    return length
  end
  
 
  def change_to_type_id_recursive(parent=FALSE)
    new_parent="#{attrib('ID')}_#{@type}"
    if !attrib('ID').nil?
      @attribs['ID']=new_parent
    end

    if !attrib('Name').nil?
      @attribs['Name']=new_parent
    end

    if !attrib('Parent').nil? && parent
      @attribs['Parent']=parent
    end
    
    each_child {|child|
      child.change_to_type_id_recursive(new_parent)
    } 
  end
  
  def write(file,id)
    file.print "#{id}\t#{@source}\t#{@type}\t#{@start}\t#{@stop}\t#{@score}\t#{@strand}\t#{@phase}\t"
    each_tag_attrib {|tag,attrib|
      file.print "#{tag}=#{attrib};"
    }
    file.puts #Print \n
    each_child {|child|
      child.write(file,id)
    }
  end

  def add_attribs(array_attribs)
    array_attribs.each do |attrib|
      if !attrib[1].nil?
        @attribs[attrib[0]]=attrib[1]
      end
    end
  end
  
end
